package com.eactive.eai.batch.job.jobItem.ked;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_KEDBT_0710 extends DefaultTelegram implements TelegramService
{

	private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;
    /**
     * 생성자
     */
    public SEND_KEDBT_0710() {
        //화일정보수신통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //트랜잭션ID - KED 및 회원사에서 업무구분을 위하여 SET하는 문자이다.
             // 회원사에서 KED에 파일 송신시 : “CB02"
            // KED에서 회원사에 파일 송신시 : “RB02"
            compileField(1, batchDoc.getBatchMsg().getHeader().getTRXID(), this.al_FieldProps[1]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(2, this.getFldTelegramType(), this.al_FieldProps[2]);

            //응답코드 - 전문의 처리결과를 나타내는 코드로 REQUEST전문(지시 및 요구전문)에는 “000”을 SET하며 RESPONSE전문(통보 및 보고전문)에서는 해당내용을 SET한다.
            compileField(3, this.getResolveResponseCode(), this.al_FieldProps[3]);

            //회원사 코드 - 전문을 전송한 기관을 확인하기 위한 회원사 코드 이다.
            compileField(4, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[4]);

            //파일명 - 0600/0610/0800/0810 전문의 경우 Space 처리함
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //전문전송 일시 - 전문을 발신하는 회원사에서 전문을 전송하는 일자와 시간을 SET 한다.
            compileField(6, TelegramKeys.getMMddHHmmss(), this.al_FieldProps[6]);

            //관리 Command - 사용하지 않는 Field로 Space로 처리
            compileField(7, "", this.al_FieldProps[7]);

            //자료일자 - 전문을 송/수신하는 기준 연월일(YYYYMMDD)
            compileField(8, batchDoc.getBatchMsg().getHeader().getBaseDate(), this.al_FieldProps[8]);

            //자료명칭 - 사용하지 않는 Field로 Space로 처리
            compileField(9, "", this.al_FieldProps[9]);

            //자료수 - 전송할 Data 총 건수(0700,0710 전문에만 적용)
            compileField(10, ""+ batchDoc.getBatchMsg().getHeader().getTotRecCnt(), this.al_FieldProps[10]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<6; i++) { //KED전문의 헤더는 파일명까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=6; i< al_Field.size()-1; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            //성공 시 응답수신 파일 Start DB로그
            if (this.getSendResponseCode().equals(TelegramKeys.RES_CODE_SUCESS)){
                LogUtil.setLogFileStart(batchDoc);
            }

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            // KED 모든 전문은 길이가 4000바이트로 고정되어 있으며 이를 SequenceSize 로 지정하기로 한다.
            SEND_LENGTH = batchDoc.getBatchMsg().getHeader().getSequenceSize();
            // X.25 이므로 아데나 장비용 길이 바이트를 추가
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
        	logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        int telegramSize = batchDoc.getBatchMsg().getHeader().getSequenceSize();
        int preFldTotSize = 0;
        for (int i=1; i< idx; i++) {
            byte[] aField = (byte[]) this.al_Field.get(i);
            preFldTotSize += aField.length;
        }

        return telegramSize - preFldTotSize;

    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        int fldLen = getCalculatedLength(idx);
        try {
            if (idx >= this.getFieldCount() ) {
            	logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
            	logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            for (int inx = 0; inx < fldLen; inx++) {
                data[inx] = ' ';
            }
            return fldLen;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(2);
    }
//    // 거래구분코드 필드값 리턴
//    public String getTrClass()
//    {
//        return super.getFieldValueString(5);
//    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(3);
    }
//    //업무관리코드 필드값 리턴
//    public String getOpCode()
//    {
//        return super.getFieldValueString(10);
//    }
}

